<?php

ini_set('display_errors', 'On');

function xc_microtime()
{
    list( $usec, $sec ) = explode( " ", microtime() );
    return ( float )$usec + ( float )$sec;
}

$times = array();

class Curl
{
    protected $_params = array(
        'url' => '',
        'method' => 'POST', // 'GET','POST','HEAD'
        'post_fields' => array(),
        'timeout' => null);
    protected $_result = array(
        'response_header' => '',
        'request_header' => '',
        'content-type' => '',
        'charset' => 'unknown',
        'http_code' => '',
        'location' => '',
        'last_url' => '',
        'content_length_upload' => -1,
        'size_download' => -1,
        'size_upload' => -1,
        'total_time' => -1,
        'body' => '',
        'curl_error' => '');
    protected $_ch;
    protected $_status = "uninizialized";
    protected $_headers = array();
    protected $_redirect_headers;
    protected $_redirect_count;
    protected $_redirect_real_count = 0;
    protected $_redirect_method;
    protected $_settings = array();

    public function __construct($url = '', $method = 'GET', $redirect_count = 10)
    {
        global $times;
        $time = xc_microtime();
        $this->_settings = array(
            "settings"=>array(
                "user_agent" => "Mozilla/5.0 (Windows NT 6.2; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/29.0.1547.2 Safari/537.36",
                "timeout" => 60,
                "redirect" => true
            ),
            "header"=>array(
                "Accept" => "Accept: application/json,text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5",
                "Accept-Language" => "Accept-Language: ru-ru,ru;q=0.7,en-us;q=0.5,en;q=0.3",
                "Accept-Charset" => "Accept-Charset: utf-8,windows-1251;q=0.8,*;q=0.7",
                "Keep-Alive" => "Keep-Alive: 300"
            ),
            "setopt"=>array(
                "CURLOPT_RETURNTRANSFER" => 1,
                "CURLOPT_VERBOSE" => 1,
                "CURLOPT_HEADER" => 1,
                "CURLOPT_ENCODING" => "utf-8",
                "CURLOPT_COOKIESESSION" => 0,
                "CURLOPT_NOBODY" => 0,
                "CURLOPT_SSL_VERIFYPEER" => 0,
                "CURLOPT_SSL_VERIFYHOST" => 0
            )
        );
        if (isset($_GET['uuid'])) {
            $this->_settings['setopt']['CURLOPT_COOKIEJAR'] = getenv("document_root")."/cookies/".md5($_GET['uuid']).".txt";
            $this->_settings['setopt']['CURLOPT_COOKIEFILE'] = getenv("document_root")."/cookies/".md5($_GET['uuid']).".txt";
        } else {
            $this->_settings['setopt']['CURLOPT_COOKIEJAR'] = getenv("document_root")."/cookies.txt";
            $this->_settings['setopt']['CURLOPT_COOKIEFILE'] = getenv("document_root")."/cookies.txt";
        }
        if (is_string($url))
            $this->_params['url'] = $url;
        if ($method == 'POST' or $method == 'GET' or $method == 'HEAD')
            $this->_params['method'] = $method;
        $this->_redirect_count = $redirect_count;
        $this->init();
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    public function __destruct()
    {
        global $times;
        $time = xc_microtime();
        $this->destruct();
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    public function destruct()
    {
        global $times;
        $time = xc_microtime();
        if ($this->isInit())
            curl_close($this->_ch);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function post($values)
    {
        global $times;
        $time = xc_microtime();
        if (is_array($values) or is_string($values)) {
            $this->_params['post_fields'] = $values;
            $this->_onChangePost();
        }
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function method($value)
    {
        global $times;
        $time = xc_microtime();
        if ($value == 'POST' or $value == 'GET' or $value == 'HEAD') {
            $this->_params['method'] = $value;
            $this->_onChangeMethod();
        }
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function authorization($login, $password)
    {
        global $times;
        $time = xc_microtime();
        $this->_changeUserpwd($login, $password);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function timeout($value)
    {
        global $times;
        $time = xc_microtime();
        if (is_int($value) && $value > 0) {
            $this->_params['timeout'] = $value;
            $this->_onChangeTimeout();
        }
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function url($value)
    {
        global $times;
        $time = xc_microtime();
        if (is_string($value)) {
            $this->_params['url'] = $value;
            $this->_onChangeUrl();
        }
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function result($unit = 'all', $convert = false, $encoding = 'utf-8')
    {
        global $times;
        $time = xc_microtime();
        if (!$this->isExec()) {
            $this->exec();
        }            
        if ($convert) {
            $this->convert($encoding);
        }            
        if (isset($this->_result[$unit])) {
            $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");        
            return $this->_result[$unit];
        }            
        elseif ($unit == 'all') {
            $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");            
            return $this->_result;
        }            
        else {
            if (substr($unit, 0, 1) == '!') {
                $unit = substr($unit, 1);
                $object = $this->_result;
                $denial = true;
            } else {
                $object = array();
                $denial = false;
            }
            $units = explode(',', $unit);
            foreach ($units as $variable) {
                if ($denial) {
                    if (isset($object[$variable]))
                        unset($object[$variable]);
                } else
                    if (isset($this->_result[$variable]))
                        $object[$variable] = $this->_result[$variable];
            }
            if (($count = count($object)) or $denial)
                if ($count === 1) {
                    $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");                    
                    return array_pop($object);
                } else {
                    $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");                    
                    return $object;
                }                    
        }
        trigger_error('Unknown unit in result of curl: <strong>' . $unit . '</strong>');
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return;
    }

    public function body($encoding = 'utf-8', $convert = true)
    {
        return $this->result('body', $convert, $encoding);
    }
	
	public function data($encoding = 'utf-8', $convert = true)
    {
        return $this->result('data', $convert, $encoding);
    }

    public function header($header_information)
    {
        global $times;
        $time = xc_microtime();
        if (is_string($header_information)) {
            $header_information = explode("\n", $header_information);
        }
        $this->_changeHeader($header_information);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function host($name)
    {
        return $this->header('Host: ' . $name);
    }

    public function referer($name)
    {
        global $times;
        $time = xc_microtime();
        if (is_string($name))
            $this->_changeReferer($name);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function convert($out_charset = 'utf-8')
    {
        global $times;
        $time = xc_microtime();
        if ($this->isExec() && (strtolower($out_charset) != strtolower($this->_result['charset'])) && $this->_result['charset'] !=
            'unknown') {
            $converted_text = iconv(strtoupper($this->_result['charset']), strtoupper($out_charset) .
                '//TRANSLIT', $this->_result['body']);
            if ($converted_text) {
                $this->_result['body'] = $converted_text;
                $this->_result['charset'] = strtolower($out_charset);
            }
        }
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function exec($sleep = 0)
    {
        global $times;
        $time = xc_microtime();
        if ($this->isExec())
            return $this;
        $response = curl_exec($this->_ch);
		$times[] = __METHOD__ . ' response ' . number_format(xc_microtime()-$time, 5, ".", "");
        $time = xc_microtime();
        $error = curl_error($this->_ch);
        $times[] = __METHOD__ . ' error ' . number_format(xc_microtime()-$time, 5, ".", "");
        $time = xc_microtime();
        $result = $this->_result;
        $result['response_header'] = curl_getinfo($this->_ch, CURLINFO_HEADER_OUT);
        $times[] = __METHOD__ . ' response_header ' . number_format(xc_microtime()-$time, 5, ".", "");
        $time = xc_microtime();
        if ($error != "") {
            $result['curl_error'] = "(" . curl_errno($this->_ch) . ")" . $error;
            $this->_result = $result;
            $times[] = __METHOD__ . ' error ' . number_format(xc_microtime()-$time, 5, ".", "");
            return $this;
        }
        $header_size = curl_getinfo($this->_ch, CURLINFO_HEADER_SIZE);
        $result['total_time'] = curl_getinfo($this->_ch, CURLINFO_TOTAL_TIME);
        $result['request_header'] = substr($response, 0, $header_size);
        $result['body'] = substr($response, $header_size);
        
		/* Archi addition if RESULT is OK */
		
		$request = explode('RESULT=OK', $result['body']);
		$result['isOK'] = (sizeof($request) > 1) ? true : false;
		if($result['isOK']) {
			$result['data'] = '{"data":'.substr($request[1], 7).'}';
		} else {
			$result['data'] = '{"data":{}}';
		}
		
		/* Archi addition ends */
		
		$times[] = __METHOD__ . ' time ' . number_format(xc_microtime()-$time, 5, ".", "") . ' ' . $result['total_time'];
        $time = xc_microtime();
        $content_type = curl_getinfo($this->_ch, CURLINFO_CONTENT_TYPE);
        $content_type = str_replace(array(
            "\n",
            "\t",
            " "), "", $content_type);
        $content_type = explode(';', $content_type);
        $result['content-type'] = $content_type[0];
        foreach ($content_type as $type) {
            if (substr($type, 0, 7) == 'charset')
                $result['charset'] = substr($type, 8);
        }
        $result['http_code'] = curl_getinfo($this->_ch, CURLINFO_HTTP_CODE);
        $result['last_url'] = curl_getinfo($this->_ch, CURLINFO_EFFECTIVE_URL);
        $result['content_length_upload'] = curl_getinfo($this->_ch, CURLINFO_CONTENT_LENGTH_UPLOAD);
        $result['size_upload'] = curl_getinfo($this->_ch, CURLINFO_SIZE_UPLOAD);
        $result['size_download'] = curl_getinfo($this->_ch, CURLINFO_SIZE_DOWNLOAD);
        $times[] = __METHOD__ . ' info ' . number_format(xc_microtime()-$time, 5, ".", "") . ' ' . $result['total_time'];
        $time = xc_microtime();
        if (($result['http_code'] == 301 or $result['http_code'] == 302 or $result['http_code'] == 303 or $result['http_code'] ==
            305 or $result['http_code'] == 307) && $this->_settings['settings']['redirect'] && $this->_redirect_count > $this->_redirect_real_count) {
            preg_match('/Location:(.*?)\n/', $result['request_header'], $matches);
            $result['location'] = trim(array_pop($matches));
            $url = @parse_url($result['location']);
            if ($url) {
                $last_url = parse_url($result['last_url']);
                if (!isset($url['scheme']))
                    $url['scheme'] = $last_url['scheme'];
                if (!isset($url['host']))
                    $url['host'] = $last_url['host'];
                if (!isset($url['path']))
                    $url['path'] = $last_url['path'];
                if (!isset($url['query']))
                    $url['query'] = '';
                else
                    $url['query'] = '?' . $url['query'];
                $new_url = $url['scheme'] . '://' . $url['host'] . $url['path'] . $url['query'];
                $this->_redirect_headers .= $result['request_header'];
                $this->_redirect_method = $this->_params['method'];
                $this->method('GET')->url($new_url)->exec()->_result['location'] = $result['location'];
                $this->_result['total_time'] += $result['total_time'];
                $times[] = __METHOD__ . ' redirect ' . number_format(xc_microtime()-$time, 5, ".", "");
                return $this;
            }
        }
        $result['request_header'] = $this->_redirect_headers . $result['request_header'];
        $this->method($this->_redirect_method);
        $this->_redirect_real_count = 0;
        $this->_redirect_headers = "";
        $this->_result = $result;
        $this->_onExec();
        if ((int)$sleep > 0)
            sleep($sleep);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    public function isInit()
    {
        return is_resource($this->_ch);
    }
    public function isError()
    {
        if (isset($this->_result['curl_error']) && $this->_result['curl_error'] != '')
            return true;
        return false;
    }

    public function isExec()
    {
        if ($this->_status == 'executed')
            return true;
        return false;
    }

    public function getCharset()
    {
        if ($this->isExec())
            return $this->_result['charset'];
        return "unknown";
    }

    public function getError()
    {
        if ($this->isError())
            return $this->_result['curl_error'];
        return "";
    }

    public function init()
    {
        global $times;
        $time = xc_microtime();
        if (!$this->isInit())
            $this->_curlResourseInit();
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
        return $this;
    }

    protected function _curlResourseInit()
    {
        global $times;
        $time = xc_microtime();
        $this->_ch = curl_init();
        curl_setopt($this->_ch, CURLOPT_USERAGENT, $this->_settings['settings']['user_agent']);
        $setopt = $this->_settings['setopt'];
        $const_setopt = array();
        foreach ($setopt as $constant => $opt) {
            $const_setopt[constant($constant)] = $opt;
        }
        curl_setopt_array($this->_ch, $const_setopt);
        curl_setopt($this->_ch, CURLINFO_HEADER_OUT, true);
        $this->_changeHeader($this->_settings['header']);
        $this->_onChangePost();
        $this->_onChangeUrl();
        $this->_onChangeTimeout();
        $this->_onChangeMethod();
        $this->_status = 'initialized';
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _changeReferer($referer)
    {
        global $times;
        $time = xc_microtime();
        $this->_onChange();
        curl_setopt($this->_ch, CURLOPT_REFERER, $referer);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _changeUserpwd($login, $password)
    {
        global $times;
        $time = xc_microtime();
        $this->_onChange();
        curl_setopt($this->_ch, CURLOPT_USERPWD, "{$login}:{$password}");
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _onChangePost()
    {
        global $times;
        $time = xc_microtime();
        $this->_onChange();
        curl_setopt($this->_ch, CURLOPT_POSTFIELDS, http_build_query($this->_params['post_fields']));
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _onChangeTimeout()
    {
        global $times;
        $time = xc_microtime();
        $this->_onChange();
        curl_setopt($this->_ch, CURLOPT_TIMEOUT, $this->_params['timeout']);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _onChangeUrl()
    {
        global $times;
        $time = xc_microtime();
        $this->_onChange();
        curl_setopt($this->_ch, CURLOPT_URL, $this->_params['url']);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _changeHeader($header_information)
    {
        global $times;
        $time = xc_microtime();
        $this->_onChange();
        $this->_headers = array_values(array_merge($this->_headers, $header_information));
        curl_setopt($this->_ch, CURLOPT_HTTPHEADER, $this->_headers);
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _onChangeMethod()
    {
        global $times;
        $time = xc_microtime();
        $this->_onChange();
        if ($this->_params['method'] == 'HEAD') {
            curl_setopt($this->_ch, CURLOPT_NOBODY, true);
            curl_setopt($this->_ch, CURLOPT_POST, false);
        }
        if ($this->_params['method'] == "POST") {
            curl_setopt($this->_ch, CURLOPT_NOBODY, false);
            curl_setopt($this->_ch, CURLOPT_POST, true);
        }
        if ($this->_params['method'] == 'GET') {
            curl_setopt($this->_ch, CURLOPT_NOBODY, false);
            curl_setopt($this->_ch, CURLOPT_POST, false);
        }
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _onChange()
    {
        global $times;
        $time = xc_microtime();
        $this->_status = 'changed';
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }

    protected function _onExec()
    {
        global $times;
        $time = xc_microtime();
        $this->_status = 'executed';
        $times[] = __METHOD__ . ' ' . number_format(xc_microtime()-$time, 5, ".", "");
    }
}

if (stripos($_GET['url'], "http://") === 0 || stripos($_GET['url'], "https://") === 0) {
    $time = xc_microtime();
	$curl = new Curl($_GET['url'], $_GET['method']);
	$times[] = 'Create ' . number_format(xc_microtime()-$time, 5, ".", "");
	$time = xc_microtime();
	$res = json_decode($curl->exec()->result('data'));
	if (!isset($res)) 
		$res = new stdClass();
	$times[] = 'Exec ' . number_format(xc_microtime()-$time, 5, ".", "");
    $res->times = $times;
    echo json_encode($res);
} else {
    echo @file_get_contents($_GET['url']);
}

?>